#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/12/05 08:33:26 +0900>
#
# LigatureSymbolstHgDXRubyŕ\ł邩eXg
#
# Ligature Symbols
# http://kudakurage.com/ligature_symbols/

require 'dxruby'

# JgtH_ɒuttfCXg[
Font.install("./LigatureSymbols-2.11.ttf")

fnt = Font.new(72, "LigatureSymbols")
sz = 72 + 4

Window.loop do
  break if Input.keyPush?(K_ESCAPE)

  chrlist = [
    "mail", "delete", "clear", "camera", "image", "playmedia", "bell",
    "color", "light", "dark", "keyboard", "time", "car", "bus",
    "grab", "setting", "wink", "smile", "trouble", "surprise",
    "man", "woman", "game", "home", "heart", "heartempty",
    "gift", "umbrella", "android", "apple", "github",
    "aim", "chrome"
  ]

  x, y = 4, 4
  chrlist.each do |s|
    Window.drawFont(x, y, s, fnt)
    x += sz
    if x > Window.width - sz
      x = 4
      y += sz
    end
  end
end
